whitespace
[automated-distro-installer] / fai-revm
index 57e5586314f81831e695561f47b69fa2be14d045..880a91c5e0d10a3bcd6ffb8c96df36f5a9624fa8 100755 (executable)
--- a/fai-revm
+++ b/fai-revm
 
 
 
-cleanup() { :; }
-set -eE -o pipefail
-trap 'cleanup; echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
-script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
+x="$(readlink -f "$BASH_SOURCE")"
+script_dir="${x%/*}"
+source "${script_dir}/bash-trace"
 
 e() { echo "$*"; "$@"; }
 
 
 usage() {
-    cat <<EOF
+  cat <<EOF
 # Usage: ${0##*/} [OPTIONS]
 Setup fai or arch pxe (depending on $0 name)
 then start a virtual machine to test the config
@@ -34,27 +33,33 @@ then start a virtual machine to test the config
 Note, sometimes shutting down the existing demohost vm
 fails. Just run again if that happens.
 
+-d         Don't do dhcp setup for when we aren't on Ian's home network.
+-n         Create new qcow2(s) for vm. Good for testing partitioning
+           script, to ensure a blank disk.
+-p         Use pxe instead of autodiscover iso with fai.
 -r         Do not boot after install is complete
--n         Create new qcow2(s) for vm
 -h|--help  Print help and exit.
 
 Note: Uses GNU getopt options parsing style
 EOF
-    exit $1
+  exit $1
 }
 
-
+orig_args=("$@")
 new_disk=false
-temp=$(getopt -l help hnr "$@") || usage 1
+pxe=false
+temp=$(getopt -l help dnprh "$@") || usage 1
 eval set -- "$temp"
 while true; do
-    case $1 in
-        -n) new_disk=true; shift ;;
-        -r) reboot_arg=--noreboot; shift ;;
-        -h|--help) usage ;;
-        --) shift; break ;;
-        *) echo "$0: Internal error!" ; exit 1 ;;
-    esac
+  case $1 in
+    -d) dhcp_arg=-d; shift ;;
+    -n) new_disk=true; shift ;;
+    -p) pxe=true; shift ;;
+    -r) reboot_arg=--noreboot; shift ;;
+    -h|--help) usage ;;
+    --) shift; break ;;
+    *) echo "$0: Internal error!" ; exit 1 ;;
+  esac
 done
 
 
@@ -64,34 +69,53 @@ disk_count=1
 
 
 if [[ $script_dir == /a/bin/* ]]; then
-    # Copy our script elsewhere so we can develop it
-    # and save it at the same time it's running
-    rm -rf /tmp/faifreeze
-    mkdir -p /a/tmp
-    cp -ar /a/bin/fai /tmp/faifreeze
-    exec /tmp/faifreeze/${BASH_SOURCE##*/} "$@"
+  # Copy our script elsewhere so we can develop it
+  # and save it at the same time it's running
+  rm -rf /tmp/faifreeze
+  cp -ar /a/bin/fai /tmp/faifreeze
+  exec /tmp/faifreeze/${BASH_SOURCE##*/} "${orig_args[@]}"
 fi
 
 cd $script_dir
 
 is_arch_revm() {
-    [[ ${0##*/} == arch-revm ]]
+  [[ ${0##*/} == arch-revm ]]
+}
+
+cleanup() {
+  echo "doing cleanup"
+  e ./pxe-server $dhcp_arg
+  ./faiserver-disable
 }
+_errcatch_cleanup=cleanup
 
-cleanup() { ./pxe-server; }
+boot_arg=--pxe
 if is_arch_revm; then
-    ./pxe-server demohost arch
-    sleep 2
-    # via osinfo-query os. guessing arch is closest to latest fedora.
-    variant=fedora22
+  e ./pxe-server $dhcp_arg demohost arch
+  sleep 2
+  # via osinfo-query os. guessing arch is closest to latest fedora.
+  variant=fedora22
 else
-    ./pxe-server demohost fai
+  if $pxe; then
+    e ./pxe-server $dhcp_arg demohost fai
     sleep 2
-    # I don't think these variants actually make a diff for us, but I
-    # use the appropriate one when trying a new distro just in case.
-    variant=ubuntu14.04
-    #variant=ubuntu16.04
-    #variant=debian8
+  else
+    fai-monitor &
+    if [[ ! $BASEFILE_DIR ]]; then
+      BASEFILE_DIR=/tmp
+    fi
+    if [[ ! -e $BASEFILE_DIR/autodiscover.iso ]]; then
+      fai-cd -g $(readlink -f grub.cfg.autodiscover) -f -A $BASEFILE_DIR/autodiscover.iso
+    fi
+    boot_arg="--cdrom $BASEFILE_DIR/autodiscover.iso"
+    e fai-redep
+    e myfai-chboot default
+  fi
+  # I don't think these variants actually make a diff for us, but I
+  # use the appropriate one when trying a new distro just in case.
+  variant=ubuntu14.04
+  #variant=ubuntu16.04
+  #variant=debian8
 fi
 
 name=demohost
@@ -101,37 +125,46 @@ e s virshrm $name ||:
 
 disk_arg=()
 for ((i=1; i <= disk_count; i++)); do
-    f=/var/lib/libvirt/images/${name}$i
-    disk_arg+=("--disk path=$f")
-    if $new_disk || [[ ! -e $f ]]; then
-        s rm -f $f
-        e s qemu-img create -o preallocation=metadata -f qcow2 $f 20G
-    fi
+  f=/var/lib/libvirt/images/${name}$i
+  disk_arg+=("--disk path=$f")
+  if $new_disk || [[ ! -e $f ]]; then
+    s rm -f $f
+    e s qemu-img create -o preallocation=metadata -f qcow2 $f 50G
+  fi
 done
 
 if [[ $SSH_CLIENT ]]; then
-    console_arg=--noautoconsole
+  console_arg=--noautoconsole
 fi
 
+# docker makes forward default to drop, which blocks the vm pxe on flidas. easiest solution:
+s iptables -P FORWARD ACCEPT
+
 # --cpu host: this causes mkfs.btrfs to fail with a stack trace which began
 # something like:
 # init_module+0x108/0x1000 [raid6_pq]
 #
 # uniq is to stop gtk-warning spam
-e s virt-install --os-variant $variant  -n $name --pxe -r 2048 --vcpus 1 \
+# e s virt-install --os-variant $variant  -n $name --pxe -r 2048 --vcpus 1 \
+  #   ${disk_arg[*]} -w bridge=br0,mac=52:54:00:9c:ef:ad $reboot_arg \
+  #   --graphics spice,listen=0.0.0.0 $console_arg |& grep -v '^ *$' | uniq &
+
+
+e s virt-install --os-variant $variant  -n $name $boot_arg -r 2048 --vcpus 1 \
   ${disk_arg[*]} -w bridge=br0,mac=52:54:00:9c:ef:ad $reboot_arg \
   --graphics spice,listen=0.0.0.0 $console_arg |& grep -v '^ *$' | uniq &
 
+
 if [[ $SSH_CLIENT ]]; then
-    fg
+  fg
 fi
 
 sleep 30
 while ! timeout -s 9 10 ssh -oBatchMode=yes root@$name /bin/true; do
-    e sleep 5
+  e sleep 5
 done
-cleanup() { :; }
-e pxe-server
+unset _errcatch_cleanup
+e ./pxe-server $dhcp_arg
 if is_arch_revm; then
-    ./arch-init-remote $name
+  ./arch-init-remote $name
 fi